From 7a9b2e508f6361c0b3044675ffb4b3aecb280147 Mon Sep 17 00:00:00 2001
From: Melanie Plageman <melanieplageman@gmail.com>
Date: Sun, 29 Dec 2019 18:56:42 -0800
Subject: [PATCH v3] Implement Adaptive Hashjoin

Serial Hashloop Fallback:

"Chunk" the inner file into arbitrary partitions of work_mem size
offset along tuple bounds while loading the batch into the hashtable.

Note that this makes it impossible to increase nbatches during the
loading of batches after initial hashtable creation.

In preparation for doing this chunking, separate "advance batch" and
"load batch".

Implement outer tuple batch rewinding per chunk of inner batch. Would
be a simple rewind and replay of outer side for each chunk of inner if
it weren't for LOJ. Because we need to wait to emit NULL-extended
tuples for LOJ until after all chunks of inner have been processed.

To do this without incurring additional memory pressure, use a
temporary BufFile to capture the match status of each outer side
tuple. Use one bit per tuple to represent the match status, and, since
for parallel-oblivious hashjoin the outer side tuples are encountered
in a deterministic order, synchronizing the outer tuples match status
file with the outer tuples in the batch file to decide which ones to
emit NULL-extended is easy and can be done with a simple counter.

For non-hashloop fallback scenario (including batch 0), this file is
not created and unmatched outer tuples should be emitted as they are
encountered.

Parallel Hashloop Fallback:

During initial allocation of the hashtable, each time the number of
batches is increased, a new variable in the ParallelHashJoinState,
batch_increases, is incremented.

In PHJ_GROW_BATCHES_DECIDING, if pstate->batch_increases >= 2,
parallel_hashloop_fallback will be enabled for qualifying batches.
From then on, if a batch is still too large to fit into the
space_allowed, then parallel_hashloop_fallback is set on that batch.
It will not be allowed to divide further and, during execution, the
fallback strategy will be used.

For a batch which has parallel_hashloop_fallback set, tuples inserted
into the the batch's inner and outer batch files will have an
additional piece of metadata (other than the hashvalue). For the inner
side, this additional metadata is the chunk number, For the outer
side, this additional metadata is the tuple identifier--needed when
rescanning the outer side batch file for each chunk of the inner.

During execution of a parallel hashjoin batch which needs to fall
back, the worker will create an "outer match status file" which
contains a bitmap tracking which outer tuples have matched an inner
tuple. All bits in the worker's outer match status file are initially
unset. During probing, the worker will set the corresponding bit (the
bit at the index of the tuple identifier) in the outer match status
bitmap for an outer tuple which matches any inner tuple.

Workers probing a fallback batch will wait until all workers have
finished probing before moving on so that an elected worker can read
and combine the outer match status files into a single bitmap and use
it to emit unmatched outer tuples after all chunks of the inner side
have been processed.
---
 src/backend/executor/Makefile                 |    1 +
 src/backend/executor/adaptiveHashjoin.c       |  323 +++++
 src/backend/executor/nodeHash.c               |   95 +-
 src/backend/executor/nodeHashjoin.c           | 1167 +++++++++++-----
 src/backend/postmaster/pgstat.c               |   21 +
 src/backend/storage/file/buffile.c            |   64 +
 src/backend/storage/ipc/barrier.c             |   85 ++
 src/backend/utils/sort/sharedtuplestore.c     |  127 +-
 src/include/executor/adaptiveHashjoin.h       |    9 +
 src/include/executor/hashjoin.h               |   28 +-
 src/include/executor/nodeHash.h               |    5 +-
 src/include/executor/tuptable.h               |    3 +-
 src/include/nodes/execnodes.h                 |   17 +
 src/include/pgstat.h                          |    8 +
 src/include/storage/barrier.h                 |    1 +
 src/include/storage/buffile.h                 |    3 +
 src/include/storage/lwlock.h                  |    1 +
 src/include/utils/sharedtuplestore.h          |   19 +
 src/test/regress/expected/adaptive_hj.out     | 1233 +++++++++++++++++
 .../regress/expected/parallel_adaptive_hj.out |  343 +++++
 src/test/regress/parallel_schedule            |    2 +-
 src/test/regress/post_schedule                |    8 +
 src/test/regress/pre_schedule                 |  120 ++
 src/test/regress/serial_schedule              |    2 +
 src/test/regress/sql/adaptive_hj.sql          |  240 ++++
 src/test/regress/sql/parallel_adaptive_hj.sql |  182 +++
 26 files changed, 3726 insertions(+), 381 deletions(-)
 create mode 100644 src/backend/executor/adaptiveHashjoin.c
 create mode 100644 src/include/executor/adaptiveHashjoin.h
 create mode 100644 src/test/regress/expected/adaptive_hj.out
 create mode 100644 src/test/regress/expected/parallel_adaptive_hj.out
 create mode 100644 src/test/regress/post_schedule
 create mode 100644 src/test/regress/pre_schedule
 create mode 100644 src/test/regress/sql/adaptive_hj.sql
 create mode 100644 src/test/regress/sql/parallel_adaptive_hj.sql

diff --git a/src/backend/executor/Makefile b/src/backend/executor/Makefile
index a983800e4b..54799d7644 100644
--- a/src/backend/executor/Makefile
+++ b/src/backend/executor/Makefile
@@ -46,6 +46,7 @@ OBJS = \
 	nodeGroup.o \
 	nodeHash.o \
 	nodeHashjoin.o \
+	adaptiveHashjoin.o \
 	nodeIndexonlyscan.o \
 	nodeIndexscan.o \
 	nodeLimit.o \
diff --git a/src/backend/executor/adaptiveHashjoin.c b/src/backend/executor/adaptiveHashjoin.c
new file mode 100644
index 0000000000..6962ba986d
--- /dev/null
+++ b/src/backend/executor/adaptiveHashjoin.c
@@ -0,0 +1,323 @@
+#include "postgres.h"
+
+#include "access/htup_details.h"
+#include "access/parallel.h"
+#include "executor/executor.h"
+#include "executor/hashjoin.h"
+#include "executor/nodeHash.h"
+#include "executor/nodeHashjoin.h"
+#include "miscadmin.h"
+#include "pgstat.h"
+#include "utils/memutils.h"
+#include "utils/sharedtuplestore.h"
+
+#include "executor/adaptiveHashjoin.h"
+
+
+
+
+bool
+ExecParallelHashJoinNewChunk(HashJoinState *hjstate, bool advance_from_probing)
+{
+	HashJoinTable hashtable;
+	int batchno;
+	ParallelHashJoinBatch *phj_batch;
+	SharedTuplestoreAccessor *outer_tuples;
+	SharedTuplestoreAccessor *inner_tuples;
+	Barrier *chunk_barrier;
+
+	hashtable = hjstate->hj_HashTable;
+	batchno = hashtable->curbatch;
+	phj_batch = hashtable->batches[batchno].shared;
+	outer_tuples = hashtable->batches[batchno].outer_tuples;
+	inner_tuples = hashtable->batches[batchno].inner_tuples;
+
+	/*
+	 * This chunk_barrier is initialized in the ELECTING phase when this worker
+	 * attached to the batch in ExecParallelHashJoinNewBatch()
+	 */
+	chunk_barrier = &hashtable->batches[batchno].shared->chunk_barrier;
+
+	/*
+	 * If this worker just came from probing (from HJ_SCAN_BUCKET) we need to
+	 * advance the chunk number here. Otherwise this worker isn't attached yet
+	 * to the chunk barrier.
+	 */
+	if (advance_from_probing)
+	{
+		/*
+		 * The current chunk number can't be incremented if *any* worker isn't
+		 * done yet (otherwise they might access the wrong data structure!)
+		 */
+		if (BarrierArriveAndWait(chunk_barrier,
+		                         WAIT_EVENT_HASH_CHUNK_PROBING))
+			phj_batch->current_chunk_num++;
+
+		/* Once the barrier is advanced we'll be in the DONE phase */
+	}
+	else
+		BarrierAttach(chunk_barrier);
+
+	/*
+	 * The outer side is exhausted and either
+	 * 1) the current chunk of the inner side is exhausted and it is time to advance the chunk
+	 * 2) the last chunk of the inner side is exhausted and it is time to advance the batch
+	 */
+	switch (BarrierPhase(chunk_barrier))
+	{
+		// TODO: remove this phase and coordinate access to hashtable above goto and after incrementing current_chunk_num
+		case PHJ_CHUNK_ELECTING:
+		phj_chunk_electing:
+			BarrierArriveAndWait(chunk_barrier,
+									 WAIT_EVENT_HASH_CHUNK_ELECTING);
+			/* Fall through. */
+
+		case PHJ_CHUNK_LOADING:
+			/* Start (or join in) loading the next chunk of inner tuples. */
+			sts_begin_parallel_scan(inner_tuples);
+
+			MinimalTuple  tuple;
+			tupleMetadata metadata;
+
+			while ((tuple = sts_parallel_scan_next(inner_tuples, &metadata)))
+			{
+				if (metadata.tupleid != phj_batch->current_chunk_num)
+					continue;
+
+				ExecForceStoreMinimalTuple(tuple,
+										   hjstate->hj_HashTupleSlot,
+										   false);
+
+				ExecParallelHashTableInsertCurrentBatch(
+					hashtable,
+					hjstate->hj_HashTupleSlot,
+					metadata.hashvalue);
+			}
+			sts_end_parallel_scan(inner_tuples);
+			BarrierArriveAndWait(chunk_barrier,
+								 WAIT_EVENT_HASH_CHUNK_LOADING);
+			/* Fall through. */
+
+		case PHJ_CHUNK_PROBING:
+			sts_begin_parallel_scan(outer_tuples);
+			return true;
+
+		case PHJ_CHUNK_DONE:
+
+			BarrierArriveAndWait(chunk_barrier, WAIT_EVENT_HASH_CHUNK_DONE);
+
+			if (phj_batch->current_chunk_num > phj_batch->total_num_chunks)
+			{
+				BarrierDetach(chunk_barrier);
+				return false;
+			}
+
+			/*
+			 * Otherwise it is time for the next chunk.
+			 * One worker should reset the hashtable
+			 */
+			if (BarrierArriveExplicitAndWait(chunk_barrier, PHJ_CHUNK_ELECTING, WAIT_EVENT_HASH_ADVANCE_CHUNK))
+			{
+				/* rewind/reset outer tuplestore and rewind outer match status files */
+				sts_reinitialize(outer_tuples);
+
+				/* reset inner's hashtable and recycle the existing bucket array. */
+				dsa_pointer_atomic *buckets = (dsa_pointer_atomic *)
+						dsa_get_address(hashtable->area, phj_batch->buckets);
+				for (size_t i = 0; i < hashtable->nbuckets; ++i)
+					dsa_pointer_atomic_write(&buckets[i], InvalidDsaPointer);
+
+				// TODO: this will unfortunately rescan all inner tuples in the batch for each chunk
+				// should be able to save the block in the file which starts the next chunk instead
+				sts_reinitialize(inner_tuples);
+			}
+			goto phj_chunk_electing;
+
+		case PHJ_CHUNK_FINAL:
+			BarrierDetach(chunk_barrier);
+			return false;
+
+		default:
+			elog(ERROR, "unexpected chunk phase %d. pid %i. batch %i.",
+				 BarrierPhase(chunk_barrier), MyProcPid, batchno);
+	}
+
+	return false;
+}
+
+
+/*
+ * Choose a batch to work on, and attach to it.  Returns true if successful,
+ * false if there are no more batches.
+ */
+bool
+ExecParallelHashJoinNewBatch(HashJoinState *hjstate)
+{
+	HashJoinTable hashtable = hjstate->hj_HashTable;
+	int			start_batchno;
+	int			batchno;
+
+	/*
+	 * If we started up so late that the batch tracking array has been freed
+	 * already by ExecHashTableDetach(), then we are finished.  See also
+	 * ExecParallelHashEnsureBatchAccessors().
+	 */
+	if (hashtable->batches == NULL)
+		return false;
+
+	/*
+	 * For hashloop fallback only
+	 * Only the elected worker who was chosen to combine the outer match status bitmaps
+	 * should reach here. This worker must do some final cleanup and then detach from the batch
+	 */
+	if (hjstate->combined_bitmap != NULL)
+	{
+		BufFileClose(hjstate->combined_bitmap);
+		hjstate->combined_bitmap = NULL;
+		hashtable->batches[hashtable->curbatch].done = true;
+		ExecHashTableDetachBatch(hashtable);
+	}
+
+	/*
+	 * If we were already attached to a batch, remember not to bother checking
+	 * it again, and detach from it (possibly freeing the hash table if we are
+	 * last to detach).
+	 * curbatch is set when the batch_barrier phase is either PHJ_BATCH_LOADING
+	 * or PHJ_BATCH_CHUNKING (note that the PHJ_BATCH_LOADING case will fall through
+	 * to the PHJ_BATCH_CHUNKING case). The PHJ_BATCH_CHUNKING case returns to the
+	 * caller. So when this function is reentered with a curbatch >= 0 then we must
+	 * be done probing.
+	 */
+	if (hashtable->curbatch >= 0)
+	{
+		ParallelHashJoinBatchAccessor *accessor = hashtable->batches + hashtable->curbatch;
+		ParallelHashJoinBatch *batch = accessor->shared;
+
+		/*
+		 * End the parallel scan on the outer tuples before we arrive at the next barrier
+		 * so that the last worker to arrive at that barrier can reinitialize the SharedTuplestore
+		 * for another parallel scan.
+		 */
+
+		if (!batch->parallel_hashloop_fallback)
+			BarrierArriveAndWait(&batch->batch_barrier,
+			                     WAIT_EVENT_HASH_BATCH_PROBING);
+		else
+		{
+			sts_close_outer_match_status_file(accessor->outer_tuples);
+
+			/*
+			 * If all workers (including this one) have finished probing the batch, one worker is elected to
+			 * Combine all the outer match status files from the workers who were attached to this batch
+			 * Loop through the outer match status files from all workers that were attached to this batch
+			 * Combine them into one bitmap
+			 * Use the bitmap, loop through the outer batch file again, and emit unmatched tuples
+			 */
+
+			if (BarrierArriveAndWait(&batch->batch_barrier,
+									 WAIT_EVENT_HASH_BATCH_PROBING))
+			{
+				hjstate->combined_bitmap = sts_combine_outer_match_status_files(accessor->outer_tuples);
+				hjstate->last_worker = true;
+				return true;
+			}
+		}
+
+		/* the elected combining worker should not reach here */
+		hashtable->batches[hashtable->curbatch].done = true;
+		ExecHashTableDetachBatch(hashtable);
+	}
+
+	/*
+	 * Search for a batch that isn't done.  We use an atomic counter to start
+	 * our search at a different batch in every participant when there are
+	 * more batches than participants.
+	 */
+	batchno = start_batchno =
+			pg_atomic_fetch_add_u32(&hashtable->parallel_state->distributor, 1) %
+			hashtable->nbatch;
+
+	do
+	{
+		if (!hashtable->batches[batchno].done)
+		{
+			Barrier *batch_barrier =
+					&hashtable->batches[batchno].shared->batch_barrier;
+
+			switch (BarrierAttach(batch_barrier))
+			{
+				case PHJ_BATCH_ELECTING:
+					/* One backend allocates the hash table. */
+					if (BarrierArriveAndWait(batch_barrier,
+											 WAIT_EVENT_HASH_BATCH_ELECTING))
+					{
+						ExecParallelHashTableAlloc(hashtable, batchno);
+						Barrier *chunk_barrier =
+								&hashtable->batches[batchno].shared->chunk_barrier;
+						BarrierInit(chunk_barrier, 0);
+						hashtable->batches[batchno].shared->current_chunk_num = 1;
+					}
+					/* Fall through. */
+
+				case PHJ_BATCH_ALLOCATING:
+					/* Wait for allocation to complete. */
+					BarrierArriveAndWait(batch_barrier,
+										 WAIT_EVENT_HASH_BATCH_ALLOCATING);
+					/* Fall through. */
+
+				case PHJ_BATCH_CHUNKING:
+					/*
+					 * This batch is ready to probe.  Return control to
+					 * caller. We stay attached to batch_barrier so that the
+					 * hash table stays alive until everyone's finished
+					 * probing it, but no participant is allowed to wait at
+					 * this barrier again (or else a deadlock could occur).
+					 * All attached participants must eventually call
+					 * BarrierArriveAndDetach() so that the final phase
+					 * PHJ_BATCH_DONE can be reached.
+					 */
+					ExecParallelHashTableSetCurrentBatch(hashtable, batchno);
+
+					if (batchno == 0)
+						sts_begin_parallel_scan(hashtable->batches[batchno].outer_tuples);
+					/*
+					 * Create an outer match status file for this batch for this worker
+					 * This file must be accessible to the other workers
+					 * But *only* written to by this worker.
+					 * Written to by this worker and readable by any worker
+					 */
+					if (hashtable->batches[batchno].shared->parallel_hashloop_fallback)
+						sts_make_outer_match_status_file(hashtable->batches[batchno].outer_tuples);
+
+					return true;
+
+				case PHJ_BATCH_OUTER_MATCH_STATUS_PROCESSING:
+					/*
+					 * The batch isn't done but this worker can't contribute
+					 * anything to it so it might as well be done from this
+					 * worker's perspective. (Only one worker can do work in
+					 * this phase).
+					 */
+
+					/* Fall through. */
+
+				case PHJ_BATCH_DONE:
+					/*
+					 * Already done. Detach and go around again (if any remain).
+					 */
+					BarrierDetach(batch_barrier);
+
+					hashtable->batches[batchno].done = true;
+					hashtable->curbatch = -1;
+					break;
+
+				default:
+					elog(ERROR, "unexpected batch phase %d. pid %i. batchno %i.",
+						 BarrierPhase(batch_barrier), MyProcPid, batchno);
+			}
+		}
+		batchno = (batchno + 1) % hashtable->nbatch;
+	} while (batchno != start_batchno);
+
+	return false;
+}
diff --git a/src/backend/executor/nodeHash.c b/src/backend/executor/nodeHash.c
index 568938667f..76e174a9b4 100644
--- a/src/backend/executor/nodeHash.c
+++ b/src/backend/executor/nodeHash.c
@@ -588,7 +588,7 @@ ExecHashTableCreate(HashState *state, List *hashOperators, List *hashCollations,
 		 * Attach to the build barrier.  The corresponding detach operation is
 		 * in ExecHashTableDetach.  Note that we won't attach to the
 		 * batch_barrier for batch 0 yet.  We'll attach later and start it out
-		 * in PHJ_BATCH_PROBING phase, because batch 0 is allocated up front
+		 * in PHJ_BATCH_CHUNKING phase, because batch 0 is allocated up front
 		 * and then loaded while hashing (the standard hybrid hash join
 		 * algorithm), and we'll coordinate that using build_barrier.
 		 */
@@ -1061,7 +1061,9 @@ ExecParallelHashIncreaseNumBatches(HashJoinTable hashtable)
 	int			i;
 
 	Assert(BarrierPhase(&pstate->build_barrier) == PHJ_BUILD_HASHING_INNER);
-
+	LWLockAcquire(&pstate->lock, LW_EXCLUSIVE);
+	pstate->batch_increases++;
+	LWLockRelease(&pstate->lock);
 	/*
 	 * It's unlikely, but we need to be prepared for new participants to show
 	 * up while we're in the middle of this operation so we need to switch on
@@ -1216,11 +1218,17 @@ ExecParallelHashIncreaseNumBatches(HashJoinTable hashtable)
 			{
 				bool		space_exhausted = false;
 				bool		extreme_skew_detected = false;
+				bool		excessive_batch_num_increases = false;
 
 				/* Make sure that we have the current dimensions and buckets. */
 				ExecParallelHashEnsureBatchAccessors(hashtable);
 				ExecParallelHashTableSetCurrentBatch(hashtable, 0);
 
+				LWLockAcquire(&pstate->lock, LW_EXCLUSIVE);
+				if (pstate->batch_increases >= 2)
+					excessive_batch_num_increases = true;
+				LWLockRelease(&pstate->lock);
+
 				/* Are any of the new generation of batches exhausted? */
 				for (i = 0; i < hashtable->nbatch; ++i)
 				{
@@ -1233,6 +1241,14 @@ ExecParallelHashIncreaseNumBatches(HashJoinTable hashtable)
 
 						space_exhausted = true;
 
+						// only once we've increased the number of batches overall many times should we start setting
+						// some batches to use the fallback strategy. Those that are still too big will have this option set
+						// we better not repartition again (growth should be disabled), so that we don't overwrite this value
+						// this tells us if we have set fallback to true or not and how many chunks -- useful for seeing how many chunks
+						// we can get to before setting it to true (since we still mark chunks (work_mem sized chunks)) in batches even if we don't fall back
+						// same for below but opposite
+						if (excessive_batch_num_increases == true)
+							batch->parallel_hashloop_fallback = true;
 						/*
 						 * Did this batch receive ALL of the tuples from its
 						 * parent batch?  That would indicate that further
@@ -1248,6 +1264,8 @@ ExecParallelHashIncreaseNumBatches(HashJoinTable hashtable)
 				/* Don't keep growing if it's not helping or we'd overflow. */
 				if (extreme_skew_detected || hashtable->nbatch >= INT_MAX / 2)
 					pstate->growth = PHJ_GROWTH_DISABLED;
+				else if (excessive_batch_num_increases && space_exhausted)
+					pstate->growth = PHJ_GROWTH_DISABLED;
 				else if (space_exhausted)
 					pstate->growth = PHJ_GROWTH_NEED_MORE_BATCHES;
 				else
@@ -1315,9 +1333,26 @@ ExecParallelHashRepartitionFirst(HashJoinTable hashtable)
 				MAXALIGN(HJTUPLE_OVERHEAD + tuple->t_len);
 
 				/* It belongs in a later batch. */
+				ParallelHashJoinBatch *phj_batch = hashtable->batches[batchno].shared;
+
+				LWLockAcquire(&phj_batch->lock, LW_EXCLUSIVE);
+				// TODO: should I check batch estimated size here at all?
+				if (phj_batch->parallel_hashloop_fallback == true && (phj_batch->estimated_chunk_size + tuple_size > hashtable->parallel_state->space_allowed))
+				{
+					phj_batch->total_num_chunks++;
+					phj_batch->estimated_chunk_size = tuple_size;
+				}
+				else
+					phj_batch->estimated_chunk_size += tuple_size;
+
+				tupleMetadata metadata;
+				metadata.hashvalue = hashTuple->hashvalue;
+				metadata.tupleid = phj_batch->total_num_chunks;
+				LWLockRelease(&phj_batch->lock);
+
 				hashtable->batches[batchno].estimated_size += tuple_size;
 				sts_puttuple(hashtable->batches[batchno].inner_tuples,
-							 &hashTuple->hashvalue, tuple);
+							 &metadata, tuple);
 			}
 
 			/* Count this tuple. */
@@ -1369,12 +1404,14 @@ ExecParallelHashRepartitionRest(HashJoinTable hashtable)
 
 		/* Scan one partition from the previous generation. */
 		sts_begin_parallel_scan(old_inner_tuples[i]);
-		while ((tuple = sts_parallel_scan_next(old_inner_tuples[i], &hashvalue)))
+		tupleMetadata metadata;
+		while ((tuple = sts_parallel_scan_next(old_inner_tuples[i], &metadata)))
 		{
 			size_t		tuple_size = MAXALIGN(HJTUPLE_OVERHEAD + tuple->t_len);
 			int			bucketno;
 			int			batchno;
 
+			hashvalue = metadata.hashvalue;
 			/* Decide which partition it goes to in the new generation. */
 			ExecHashGetBucketAndBatch(hashtable, hashvalue, &bucketno,
 									  &batchno);
@@ -1383,10 +1420,23 @@ ExecParallelHashRepartitionRest(HashJoinTable hashtable)
 			++hashtable->batches[batchno].ntuples;
 			++hashtable->batches[i].old_ntuples;
 
+			ParallelHashJoinBatch *phj_batch = hashtable->batches[batchno].shared;
+			LWLockAcquire(&phj_batch->lock, LW_EXCLUSIVE);
+			// TODO: should I check batch estimated size here at all?
+			if (phj_batch->parallel_hashloop_fallback == true && (phj_batch->estimated_chunk_size + tuple_size > pstate->space_allowed))
+			{
+				phj_batch->total_num_chunks++;
+				phj_batch->estimated_chunk_size = tuple_size;
+			}
+			else
+				phj_batch->estimated_chunk_size += tuple_size;
+			metadata.tupleid = phj_batch->total_num_chunks;
+			LWLockRelease(&phj_batch->lock);
 			/* Store the tuple its new batch. */
 			sts_puttuple(hashtable->batches[batchno].inner_tuples,
-						 &hashvalue, tuple);
+						 &metadata, tuple);
 
+			// TODO: should I zero out metadata here to make sure old values aren't reused?
 			CHECK_FOR_INTERRUPTS();
 		}
 		sts_end_parallel_scan(old_inner_tuples[i]);
@@ -1719,7 +1769,7 @@ retry:
 		size_t		tuple_size = MAXALIGN(HJTUPLE_OVERHEAD + tuple->t_len);
 
 		Assert(batchno > 0);
-
+		ParallelHashJoinState *pstate = hashtable->parallel_state;
 		/* Try to preallocate space in the batch if necessary. */
 		if (hashtable->batches[batchno].preallocated < tuple_size)
 		{
@@ -1729,7 +1779,25 @@ retry:
 
 		Assert(hashtable->batches[batchno].preallocated >= tuple_size);
 		hashtable->batches[batchno].preallocated -= tuple_size;
-		sts_puttuple(hashtable->batches[batchno].inner_tuples, &hashvalue,
+		ParallelHashJoinBatch *phj_batch = hashtable->batches[batchno].shared;
+		LWLockAcquire(&phj_batch->lock, LW_EXCLUSIVE);
+
+		// TODO: should batch estimated size be considered here?
+		// TODO: should this be done in ExecParallelHashTableInsertCurrentBatch instead?
+		if (phj_batch->parallel_hashloop_fallback == true && (phj_batch->estimated_chunk_size + tuple_size > pstate->space_allowed))
+		{
+			phj_batch->total_num_chunks++;
+			phj_batch->estimated_chunk_size = tuple_size;
+		}
+		else
+			phj_batch->estimated_chunk_size += tuple_size;
+
+		tupleMetadata metadata;
+		metadata.hashvalue = hashvalue;
+		metadata.tupleid = phj_batch->total_num_chunks;
+		LWLockRelease(&phj_batch->lock);
+
+		sts_puttuple(hashtable->batches[batchno].inner_tuples, &metadata,
 					 tuple);
 	}
 	++hashtable->batches[batchno].ntuples;
@@ -2936,6 +3004,13 @@ ExecParallelHashJoinSetUpBatches(HashJoinTable hashtable, int nbatch)
 		ParallelHashJoinBatch *shared = NthParallelHashJoinBatch(batches, i);
 		char		name[MAXPGPATH];
 
+		shared->parallel_hashloop_fallback = false;
+		LWLockInitialize(&shared->lock,
+		                 LWTRANCHE_PARALLEL_HASH_JOIN_BATCH);
+		shared->current_chunk_num = 0;
+		shared->total_num_chunks = 1;
+		shared->estimated_chunk_size = 0;
+
 		/*
 		 * All members of shared were zero-initialized.  We just need to set
 		 * up the Barrier.
@@ -2945,7 +3020,7 @@ ExecParallelHashJoinSetUpBatches(HashJoinTable hashtable, int nbatch)
 		{
 			/* Batch 0 doesn't need to be loaded. */
 			BarrierAttach(&shared->batch_barrier);
-			while (BarrierPhase(&shared->batch_barrier) < PHJ_BATCH_PROBING)
+			while (BarrierPhase(&shared->batch_barrier) < PHJ_BATCH_CHUNKING)
 				BarrierArriveAndWait(&shared->batch_barrier, 0);
 			BarrierDetach(&shared->batch_barrier);
 		}
@@ -2959,7 +3034,7 @@ ExecParallelHashJoinSetUpBatches(HashJoinTable hashtable, int nbatch)
 			sts_initialize(ParallelHashJoinBatchInner(shared),
 						   pstate->nparticipants,
 						   ParallelWorkerNumber + 1,
-						   sizeof(uint32),
+						   sizeof(tupleMetadata),
 						   SHARED_TUPLESTORE_SINGLE_PASS,
 						   &pstate->fileset,
 						   name);
@@ -2969,7 +3044,7 @@ ExecParallelHashJoinSetUpBatches(HashJoinTable hashtable, int nbatch)
 													  pstate->nparticipants),
 						   pstate->nparticipants,
 						   ParallelWorkerNumber + 1,
-						   sizeof(uint32),
+						   sizeof(tupleMetadata),
 						   SHARED_TUPLESTORE_SINGLE_PASS,
 						   &pstate->fileset,
 						   name);
